use actix_web_actors::ws::WebsocketContext;
use elm_rs::{Elm, ElmDecode, ElmEncode};
use serde::{Deserialize, Serialize};

type BackendType = crate::TryItBackend;

#[derive(Serialize, Debug, Elm, ElmDecode)]
pub enum LandingDownMsg {
    Greeting(String),
    TimeUpdate(String),
}

#[derive(Deserialize, Debug, Elm, ElmEncode)]
pub enum LandingUpMsg {
    RequestGreet(String),
}

pub fn cleanup(actor_instance: &mut BackendType, ctx: &mut WebsocketContext<BackendType>) {}

pub fn msg_handler(
    msg: LandingUpMsg,
    actor_instance: &mut crate::TryItBackend,
    ctx: &mut WebsocketContext<BackendType>,
) {
    match msg {
        LandingUpMsg::RequestGreet(name) => {
            let greeting = format!("Hello, {}!", name);
            let response = crate::DownMsg::LandingDownMsg(LandingDownMsg::Greeting(greeting));
            actor_instance.send_down_msg(response, ctx);
        }
    }
}
